/*
 *    о
 *  userRoot()   //HKEY_CURRENT_USER
 *  systemRoot() //HKEY_LOCAL_MACHINE
 */

package com.pmguda.winexit;

import java.lang.reflect.Method;
import java.util.prefs.Preferences;


public class WinRegistry {

	private static final int KEY_READ = 0x20019;
	
	private static final Preferences userRoot = Preferences.userRoot();      //HKEY_CURRENT_USER
	private static final Preferences systemRoot = Preferences.systemRoot();  //HKEY_LOCAL_MACHINE
	
	public String getRegVal(String regType, String regPath, String sKey) {
		final Class clz = userRoot.getClass();
		String vals = null;
		String key = sKey;
		try {
			
			final Method openKey = clz.getDeclaredMethod("openKey",byte[].class, int.class, int.class);
			openKey.setAccessible(true);
			final Method closeKey = clz.getDeclaredMethod("closeKey", int.class);
			closeKey.setAccessible(true);
			final Method winRegQueryValue = clz.getDeclaredMethod("WindowsRegQueryValueEx", int.class, byte[].class);
			winRegQueryValue.setAccessible(true);
			final Method winRegEnumValue = clz.getDeclaredMethod("WindowsRegEnumValue1", int.class, int.class, int.class);
			winRegEnumValue.setAccessible(true);
			final Method winRegQueryInfo = clz.getDeclaredMethod("WindowsRegQueryInfoKey1", int.class);
			winRegQueryInfo.setAccessible(true);
			byte[] valb = null;
			
			Integer handle = -1; // Query Internet Settings for Proxy
			
			if(regType.equals("HKEY_CURRENT_USER")) {
				handle = (Integer) openKey.invoke(userRoot, toCstr(regPath), KEY_READ,KEY_READ);  //
				valb = (byte[]) winRegQueryValue.invoke(userRoot,
						handle.intValue(), toCstr(key));
				vals = (valb != null ? new String(valb).trim() : null);
				closeKey.invoke(Preferences.userRoot(), handle); // Query for IE
			} else if (regType.equals("HKEY_LOCAL_MACHINE") ){
				handle = (Integer) openKey.invoke(systemRoot, toCstr(regPath),KEY_READ, KEY_READ);
				valb = (byte[]) winRegQueryValue.invoke(systemRoot, handle,toCstr(key));
				vals = (valb != null ? new String(valb).trim() : null);
				closeKey.invoke(Preferences.systemRoot(), handle);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vals;
	}
	
	private static byte[] toCstr(String str) {
		byte[] result = new byte[str.length() + 1];
		for (int i = 0; i < str.length(); i++) {
			result[i] = (byte) str.charAt(i);
		}
		result[str.length()] = 0;
		return result;
	}
}
