package com.pmguda.winexit;
import java.awt.AWTException;
import java.awt.Image;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.SystemTray;
import java.awt.Toolkit;
import java.awt.TrayIcon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

public class WinTray {
	
	private TrayIcon trayIcon;
	private JFrame  mainFrame;
	private PopupMenu popup;
	
	//////////⺻  /////////////////////
	public WinTray() {
		if (SystemTray.isSupported()) {
	          SystemTray tray = SystemTray.getSystemTray();
	          Image image = Toolkit.getDefaultToolkit().getImage("image/tray.gif");
	          popup = new PopupMenu();          
	          trayIcon = new TrayIcon(image, ":", popup);
	          trayIcon.setImageAutoSize(true);
	          trayIcon.addActionListener(TrayListener);
	          try {
	        	  tray.add(trayIcon); //SystemTray Ʈ  ߰
	          } catch (AWTException e) {
	        	  e.printStackTrace(); 
	          }
	        } else {
	          System.err.println("Tray unavailable");
	        }
	}
	
	/////////frame  /////////////////////
	public WinTray(JFrame frame,String toolTip) {
		
		this.mainFrame = frame; //frame â
		
		if (SystemTray.isSupported()) {
          SystemTray tray = SystemTray.getSystemTray();
          Image image = Toolkit.getDefaultToolkit().getImage("image/tray.gif");
          PopupMenu popup = new PopupMenu();
          MenuItem item = new MenuItem("Exit");
          item.addActionListener(exitListener);
          popup.add(item);
                
          trayIcon = new TrayIcon(image, toolTip, popup);
          trayIcon.setImageAutoSize(true);
          trayIcon.addActionListener(TrayListener);
          try {
        	  tray.add(trayIcon); //SystemTray Ʈ  ߰
          } catch (AWTException e) {
        	  e.printStackTrace(); 
          }
        } else {
          System.err.println("Tray unavailable");
        }
	}
	
/////////α׷ ̸  /////////////////////
	public WinTray(String appName) {
		
		if (SystemTray.isSupported()) {
          SystemTray tray = SystemTray.getSystemTray();
          Image image = Toolkit.getDefaultToolkit().getImage("image/guda.ico");
          PopupMenu popup = new PopupMenu();
          MenuItem item = new MenuItem("Exit");
          item.addActionListener(exitListener);
          popup.add(item);
                
          trayIcon = new TrayIcon(image, appName, popup);
          trayIcon.setImageAutoSize(true);
          trayIcon.addActionListener(TrayListener);
          try {
        	  tray.add(trayIcon); //SystemTray Ʈ  ߰
          } catch (AWTException e) {
        	  e.printStackTrace(); 
          }
        } else {
          System.err.println("Tray unavailable");
        }
	}
	
	/////////popup ޴ MenuItem ߰  /////////////
	public void setMenuItem(MenuItem menuitem)	{
		this.popup.add(menuitem);
	}
	
	//////////  ̺Ʈ   //////////////////////
	ActionListener exitListener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
           System.exit(0);
        }
    };
    
    //////////Ʈ ̺Ʈ  (α׷  ) //
	ActionListener TrayListener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        	mainFrame.setVisible(!mainFrame.isVisible());
        }
    };
}